#include "stdafx.h"
#include "BMLBulletML.h"
#include "BMLDLL.h"
#include <dkutil/dkutilDefinedC.h>
#include <DxEx/DxExIndependent.h>


#ifdef NDEBUG
#	pragma comment(linker,"/NODEFAULTLIB:MSVCRT")
//#	pragma comment(linker,"/NODEFAULTLIB:LIBC")
//#	pragma comment(lib,"LIBCMT")
#endif

bml::BulletMLManager *gBML = NULL;


#define CHECK_GBML_RETURN(s) {if(NULL==gBML){return s;} }
#define CHECK_GBML() {if(NULL==gBML){return ;} }


BOOL WINAPI DllMain(
  HINSTANCE hinstDLL,  // DLL W[̃nh
  DWORD fdwReason,     // ֐ĂяoR
  LPVOID lpvReserved   // \ς
	){

	//TRUEv
	return TRUE;
}



int WINAPI BML_Init(int bulletnum,double  bulletspeed,int queuenum)
{
	if(NULL!=gBML){return edk_LogicError;}
	gBML = new bml::BulletMLManager;
	if(!gBML){return edk_OutOfMemory;}

	if(false==gBML->Init(bulletnum,bulletspeed,queuenum)){
		return edk_FAILED;
	}
	return edk_SUCCEEDED;
}

///IB
int WINAPI BML_End(){
	if(NULL==gBML){return edk_LogicError;}
	gBML->End();
	delete gBML;
	gBML = NULL;
	return edk_SUCCEEDED;
}
/*
@param filename[in] BulletMLf[^`ĂXMLt@CBigq͉łǂB
@return [hςXML̃nh
*/
int WINAPI BML_LoadXMLFile(const char *filename){
	CHECK_GBML_RETURN(edk_LogicError);
	return gBML->LoadBMLFile(filename);
}
/*
@param memory[in] [hςXMLւ̃̈ւ̃|C^i̍Ō͕KNULLł邱ƁB
@return [hςXMLnh
*/
int WINAPI BML_LoadXMLFromMemory(const char *memory){
	CHECK_GBML_RETURN(edk_LogicError);
	return gBML->LoadBML(memory);
}

///e𐶐B
int WINAPI BML_CreateBullet(
	int handle,int x,int y,
		const char *work,size_t worksize,BML_GETPLAYER_DATA_CALLBACK callback)
{
	CHECK_GBML_RETURN(edk_LogicError);
	bool r = gBML->CreateBullet(handle,x,y,work,worksize,callback);
	return (true == r) ? edk_SUCCEEDED : edk_FAILED;
}

///܂Őꂽe𓮂B
int WINAPI BML_Move(){
	CHECK_GBML_RETURN(edk_LogicError);
	gBML->Move();
	return edk_SUCCEEDED;
}
///libBulletMLsPt[Ԃ̏B
int WINAPI BML_Update(){
	CHECK_GBML_RETURN(edk_LogicError);
	gBML->Update();
	return edk_SUCCEEDED;
}

///VvȒe̊i[ւ̃AhX擾
BML_BULLET_DATA * WINAPI BML_GetSimpleBulletAddress()
{
	CHECK_GBML_RETURN(NULL);
	return gBML->GetSimpleAddress();
}
///VvȒeւ̊i[̃AhX͓Yʂĉ܂ŃANZX\ǂ̐ԂB
size_t WINAPI BML_GetSimpleBulletSentinel(){
	CHECK_GBML_RETURN(0);
	return gBML->GetSimpleSentinel();
}
///VvȒe폜B
void WINAPI BML_DeleteSimpleBullet(BML_BULLET_DATA *data){
	CHECK_GBML();
	gBML->DeleteSimpleBullet(data);
}

///ANVȒe̊i[ւ̃AhX擾
BML_BULLET_DATA * WINAPI BML_GetActionBulletAddress(){
	CHECK_GBML_RETURN(NULL);
	return gBML->GetActionAddress();
}
///ANVȒeւ̊i[̃AhX͓Yʂĉ܂ŃANZX\̐ԂB
size_t  WINAPI BML_GetActionBulletSentinel(){
	CHECK_GBML_RETURN(0);
	return gBML->GetActionSentinel();
}
///ANVȒe폜B
void WINAPI BML_DeleteActionBullet(BML_BULLET_DATA *data){
	CHECK_GBML();
	gBML->DeleteActionBullet(data);
}

///@return ̒e̐擾B
int WINAPI BML_GetBulletNum(){
	CHECK_GBML_RETURN(0);
	return gBML->GetBulletNum();
}
///WIȒẽXs[hw肷B
void WINAPI  BML_SetBulletSpeed(double speed){
	CHECK_GBML();
	gBML->SetBulletSpeed(speed);
}
///@return WIȒẽXs[h擾
double WINAPI BML_GetBulletSpeed(){
	CHECK_GBML_RETURN(0.0f);
	return gBML->GetBulletSpeed();
}

///t[擾B
int WINAPI BML_GetFrame(){
	CHECK_GBML_RETURN(0);
	return gBML->GetFrame();
}

///t[Oɖ߂BiׂĂ̒e폜ĂĂяoƂシB
void WINAPI BML_ClearFrame(){
	CHECK_GBML();
	gBML->ClearFrame();
}
///t[グB
void WINAPI BML_IncrementFrame(){
	CHECK_GBML();
	gBML->IncFrame();
}




//**********************************************************
//ȉ̓wp֐


void DrawBoxTestHelper(BML_BULLET_DATA *data,size_t size,int RunFlag,
										int color,DRAWBOX_CALLBACK callback)
{
	int x = 0,y = 0;
	for(size_t i=0;i<size;i++)
	{
		if(RunFlag==data[i].flag)
		{
			x = data[i].x;
			y = data[i].y;
			callback(x,y,x+3,y+3,color,TRUE);
		}
	}

}

void WINAPI BML_HELPER_DrawBullet(int SimpleColor,int ActionColor,
																	DRAWBOX_CALLBACK callback)
{
	CHECK_GBML();
	if(NULL==callback){return ;}
	
	BML_BULLET_DATA *ptr;
	size_t size;
	
	ptr= BML_GetSimpleBulletAddress();
	size = BML_GetSimpleBulletSentinel();
	
	DrawBoxTestHelper(ptr,size,ebmlSIMPLE_BULLET,SimpleColor,callback);

	ptr = BML_GetActionBulletAddress();
	size = BML_GetActionBulletSentinel();

	DrawBoxTestHelper(ptr,size,ebmlACTION_BULLET,ActionColor,callback);

}

int WINAPI BML_HELPER_OpenBMLSelectDialog(char *buff,size_t buffsize,HWND wnd)
{
	bool r;
	r = dkutil::FileOpenDialog  ( buff,  
		buffsize,  
		"BulletML`f[^IłB",  
		"xml(*.xml)\0*.xml\0bml(*.bml)\0*.bml\0All files(*.*)\0*.*\0\0",  
		"xml file\0bml file\0all file\0\0",  
		wnd 
	);
	if(r==false){
		return edk_Not_Selected; 
	}

	return edk_SUCCEEDED;
}


void CALLBACK DefaultHitDeleteAction(BML_BULLET_DATA *data){
	if(ebmlACTION_BULLET == data->flag ){

		BML_DeleteActionBullet(data);

	}else if(ebmlSIMPLE_BULLET==data->flag){
		BML_DeleteSimpleBullet(data);
	}
}

BOOL CALLBACK DefaultCheckCollision(const RECT *your,BML_BULLET_DATA *data){
	RECT b={data->x,data->y,data->x + 1,data->y + 1};
	return dxex::CheckCollision(*your,b);
}


typedef void (CALLBACK *FOR_EACH_FUNC)(BML_BULLET_DATA *,void *);

void ForEachBullet(BML_BULLET_DATA *data,size_t size,int RunFlag,
									 FOR_EACH_FUNC ptr,void *yourdata)
{
	int x = 0,y = 0;
	for(size_t i=0;i<size;i++)
	{
		if(RunFlag==data[i].flag)
		{
			x = data[i].x;
			y = data[i].y;
			ptr(&data[i],yourdata);
		}
	}


}

struct HitDeleteDelegation{
	RECT collision;
	BML_HIT_DELETE_ACTION Action;
	BML_CHECK_COLLISION_CALLBACK CheckCollision;
};

void CALLBACK CheckCollisionForEachFunc(
	BML_BULLET_DATA *bullet,void *mydata)
{
	HitDeleteDelegation *d = (HitDeleteDelegation *)mydata;
	
	if(d->CheckCollision(&d->collision,bullet))
	{
		d->Action(bullet);
	}
}



//蔻ƂB
void WINAPI BML_HELPER_HitDelete(
	const RECT *your,
	BML_HIT_DELETE_ACTION Action,
	BML_CHECK_COLLISION_CALLBACK CheckCollision
	)
{
	if(!Action){
		Action = DefaultHitDeleteAction;
	}
	if(!CheckCollision){
		CheckCollision = DefaultCheckCollision;
	}

	BML_BULLET_DATA *ptr;
	size_t size;
	


	HitDeleteDelegation d;
	d.Action = Action;
	d.CheckCollision = CheckCollision;
	d.collision = *your;

	ptr= BML_GetSimpleBulletAddress();
	size = BML_GetSimpleBulletSentinel();

	ForEachBullet(ptr,size,ebmlSIMPLE_BULLET,CheckCollisionForEachFunc,(void *)&d);
	
	//DrawBoxTestHelper(ptr,size,ebmlSIMPLE_BULLET,SimpleColor,callback);

	ptr = BML_GetActionBulletAddress();
	size = BML_GetActionBulletSentinel();

	ForEachBullet(ptr,size,ebmlACTION_BULLET,CheckCollisionForEachFunc,(void *)&d);




}

//**********************************************************
//ȈՁAOp֐ƂOOG

//sin table
const float * WINAPI BML_HELPER_GetSinTable(){
	return dxex::gTrig.getsintable();
}
//sin table͂ǂ܂ňėǂ𓾂B
size_t WINAPI BML_HELPER_SinTableSentinel(){
	return dxex::gTrig.getsintablesize();
}

//@param angle[in] fBO[Ȋpx
double WINAPI BML_HELPER_AngleToCos( int angle ){
	return dxex::gTrig.AngleToCos(angle);
}
//@param angle[in] fBO[Ȋpx
double WINAPI BML_HELPER_AngleToSin( int angle ){
	return dxex::gTrig.AngleToSin(angle);
}